/*======================================================================+
| PGPC: Parallel Genetic Programming in C                               |
| (c) 1995 Genetic Algorithm Technology Corp. all rights reserved       |
|   written by David Andre                                              |
+======================================================================*/
/*======================================================================+
| FILE: startup.h                                                       |
| DESCRIPTION: Function prototypes for startup.c.                       |
|                                                                       |
| REVISIONS:                                                            |
| Jan 24, 1995:  Works as of today, no known bugs.                      |
+======================================================================*/


int old_main(void);  /*funcdef -dgpc- main*/
StartupInfo * GenerateStartupInfoForNode(int node); /*funcdef*/
void    InitializeGraphicInfo(GraphicInfo *graph_info,    /*funcdef*/
                              int         mesh_rows,      /*funcdef*/
                              int         mesh_cols,      /*funcdef*/
                              int         num_meshnodes,  /*funcdef*/
                              int         num_gens,       /*funcdef*/
                              int         run_num,        /*funcdef*/
                              char     *  problem);   /*funcdef*/
void UpdateNodeStatus(int status,                /*funcdef*/
                      GraphicInfo *graph_info,  /*funcdef*/
                      int node, int time); /*funcdef*/
void UpdateStatusOfAllNodes(GraphicInfo *graph_info,  /*funcdef*/
                            int time);          /*funcdef*/
void OutputGraphicInfo(GraphicInfo * graphic_info); /*funcdef*/
void ReadPrimedIndividuals(Population *pop); /*funcdef*/
void CreateRandomConstants(Population *pop); /*funcdef*/
void GetPerpetualNumber(int * pn); /*funcdef - startup - GetPerpetualNumber*/
void DoRandoms(Population *pop,int perpetual_number) ; /*funcdef - startup - DoRandoms*/
void DoWelcomeMessage(void); /*funcdef - startup - DoWelcomeMessage*/
void  WriteInfoToOutputFile(Population *pop,              /*funcdef - startup - WriteInfoToOutputFile*/
                           char * out_put_file_name,         /*funcdef - startup - WriteInfoToOutputFile*/
                           int perpetual_number,          /*funcdef - startup - WriteInfoToOutputFile*/
                           char * timestr);           /*funcdef - startup - WriteInfoToOutputFile*/
void ReadInputFile(char * filename,Population * spop);  /*funcdef - startup - ReadInputFile*/
void WriteToArchive(Population *pop,int perpetual_number, char * str); /*funcdef - startup - WriteToArchive*/
void	ReportToFile(int counter,    /*funcdef - startup - ReportToFile*/
                       int run_num,     /*funcdef - startup -ReportToFile*/
                       FILE * ofp);      /*funcdef - startup -ReportToFile*/
void	ReportToScreen(int counter,int run_num);   /*funcdef - startup - ReportToScreen*/
void HandleFastHeartbeat(MSGHDRTYPE * inmsg); /*funcdef*/
void HandleSlowHeartbeat(MSGHDRTYPE * inmsg); /*funcdef*/
int HandleEndOfGen(MSGHDRTYPE * inmsg,              /*funcdef*/
                   EndGenInfo *eog,                 /*funcdef*/
                   GraphicInfo *graphic_info) ; /*funcdef - startup - SendEndOfGenMessage*/
void HandleEureka(GraphicInfo *graphic_info,MSGHDRTYPE * inmsg, EurekaInfo * eureka); /*funcdef*/
void PrintMsgHeader(FILE * f, MSGHDRTYPE * msg); /*funcdef*/
void PrintIndividual(Individual * ind, FILE * ofp); /*funcdef - dgpc - PrintIndividual*/
void ReadIndividual(FILE * ofp, Individual * ind); /*funcdef - dgpc - ReadIndividual */
int GoToInFile(FILE * ofp, char * str);   /*funcdef - dgpc - GoToInFile*/
void blanks(FILE *f, int n);  /*funcdef - dgpc - blanks*/
int disspace(char ch);  /*funcdef - dgpc - disspace*/
void GetNextToken(char *buf, FILE *f); /*funcdef - dgpc - GetNextToken*/
int  ReadBranch(Branch *br, FILE *f, int index); /*funcdef - dgpc - ReadBranch*/
int FindConstantInTables(GTYPE temp, int *constant_num); /*funcdef - dgpc - FindConstantInTable*/
int PrintTree(Branch * br, int index, int depth,  FILE *f, int *counter); /*funcdef - dgpc - PrintTree*/
void WriteBranch(Branch * br, FILE *f);  /*funcdef - dgpc - WriteBranch*/
void PrintFunctionTable(FILE * ofp,Population * pop); /*funcdef - dgpc - PrintFunctionTable*/
int LookupFunctionName(char *buf);  /*funcdef - dgpc - CopySubtree*/
GTYPE EvalBranch(Branch * br); /*funcdef*/
int TraverseSubtree(Branch *br,int index); /*funcdef*/
void gpi_CondSendTrace(char *str);
int GoToCharInFile(FILE * fp, char ch);
void GotoEndBracket(FILE *f);
char GetToNonSpace(FILE * f);




